<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_module_information".
 *
 * @property int $module_id
 * @property string $module_uuid
 * @property string $module_name
 * @property string $module_tag
 * @property string $module_created_date
 * @property string $module_modified_date
 * @property string $module_status
 * @property string $module_hkey
 * @property string $module_modified_by
 * @property string $module_created_by
 * @property string $module_end_point
 * @property string $module_deleted_by
 * @property string $module_deleted_date
 * @property string $module_is_deleted
 * @property string $modified_date
 */
class SsoModuleInformation extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_module_information';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['module_uuid', 'module_name', 'module_tag', 'module_hkey', 'module_created_by', 'module_end_point'], 'required'],
            [['module_created_date', 'module_modified_date', 'module_deleted_date', 'modified_date'], 'safe'],
            [['module_status', 'module_is_deleted'], 'string'],
            [['module_uuid', 'module_name', 'module_tag', 'module_modified_by', 'module_created_by', 'module_deleted_by'], 'string', 'max' => 128],
            [['module_hkey'], 'string', 'max' => 256],
            [['module_end_point'], 'string', 'max' => 700],
            [['module_tag'], 'unique'],
            [['module_name'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'module_id' => Yii::t('app', 'Module ID'),
            'module_uuid' => Yii::t('app', 'Module Uuid'),
            'module_name' => Yii::t('app', 'Module Name'),
            'module_tag' => Yii::t('app', 'Module Tag'),
            'module_created_date' => Yii::t('app', 'Module Created Date'),
            'module_modified_date' => Yii::t('app', 'Module Modified Date'),
            'module_status' => Yii::t('app', 'Module Status'),
            'module_hkey' => Yii::t('app', 'Module Hkey'),
            'module_modified_by' => Yii::t('app', 'Module Modified By'),
            'module_created_by' => Yii::t('app', 'Module Created By'),
            'module_end_point' => Yii::t('app', 'Module End Point'),
            'module_deleted_by' => Yii::t('app', 'Module Deleted By'),
            'module_deleted_date' => Yii::t('app', 'Module Deleted Date'),
            'module_is_deleted' => Yii::t('app', 'Module Is Deleted'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoModuleInformationQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoModuleInformationQuery(get_called_class());
    }
}
