<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_module_permission".
 *
 * @property int $permission_id
 * @property string $permission_uuid
 * @property string $module_uuid
 * @property string $permission_name
 * @property string $permission_description
 * @property string $permission_status
 * @property string $permission_created_date
 * @property string $permission_modified_date
 * @property string $permission_is_deleted
 * @property string $modified_date
 */
class SsoModulePermission extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_module_permission';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['permission_uuid', 'module_uuid', 'permission_name'], 'required'],
            [['permission_description', 'permission_status', 'permission_is_deleted'], 'string'],
            [['permission_created_date', 'permission_modified_date', 'modified_date'], 'safe'],
            [['permission_uuid', 'module_uuid'], 'string', 'max' => 128],
            [['permission_name'], 'string', 'max' => 256],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'permission_id' => Yii::t('app', 'Permission ID'),
            'permission_uuid' => Yii::t('app', 'Permission Uuid'),
            'module_uuid' => Yii::t('app', 'Module Uuid'),
            'permission_name' => Yii::t('app', 'Permission Name'),
            'permission_description' => Yii::t('app', 'Permission Description'),
            'permission_status' => Yii::t('app', 'Permission Status'),
            'permission_created_date' => Yii::t('app', 'Permission Created Date'),
            'permission_modified_date' => Yii::t('app', 'Permission Modified Date'),
            'permission_is_deleted' => Yii::t('app', 'Permission Is Deleted'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoModulePermissionQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoModulePermissionQuery(get_called_class());
    }
}
