<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_update_reasons".
 *
 * @property int $id
 * @property string $uuid
 * @property string $user_uuid
 * @property string $reason
 * @property string $created_date
 * @property string $modified_date
 */
class SsoUpdateReasons extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_update_reasons';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['uuid', 'user_uuid', 'reason'], 'required'],
            [['reason'], 'string'],
            [['created_date', 'modified_date'], 'safe'],
            [['uuid', 'user_uuid'], 'string', 'max' => 64],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => Yii::t('app', 'ID'),
            'uuid' => Yii::t('app', 'Uuid'),
            'user_uuid' => Yii::t('app', 'User Uuid'),
            'reason' => Yii::t('app', 'Reason'),
            'created_date' => Yii::t('app', 'Created Date'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoUpdateReasonsQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoUpdateReasonsQuery(get_called_class());
    }
}
