<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "sso_user_token".
 *
 * @property int $token_id
 * @property string $token_uuid
 * @property string $user_uuid
 * @property string $token
 * @property string $token_created_date
 * @property string $token_expiration_date
 * @property string $token_last_refreshed
 * @property string $token_status
 * @property string $token_is_deleted
 * @property string $modified_date
 */
class SsoUserToken extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'sso_user_token';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['token_uuid', 'user_uuid', 'token', 'token_created_date', 'token_expiration_date'], 'required'],
            [['token_created_date', 'token_expiration_date', 'token_last_refreshed', 'modified_date'], 'safe'],
            [['token_status', 'token_is_deleted'], 'string'],
            [['token_uuid', 'user_uuid'], 'string', 'max' => 128],
            [['token'], 'string', 'max' => 40],
            [['token'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'token_id' => Yii::t('app', 'Token ID'),
            'token_uuid' => Yii::t('app', 'Token Uuid'),
            'user_uuid' => Yii::t('app', 'User Uuid'),
            'token' => Yii::t('app', 'Token'),
            'token_created_date' => Yii::t('app', 'Token Created Date'),
            'token_expiration_date' => Yii::t('app', 'Token Expiration Date'),
            'token_last_refreshed' => Yii::t('app', 'Token Last Refreshed'),
            'token_status' => Yii::t('app', 'Token Status'),
            'token_is_deleted' => Yii::t('app', 'Token Is Deleted'),
            'modified_date' => Yii::t('app', 'Modified Date'),
        ];
    }

    /**
     * {@inheritdoc}
     * @return SsoUserTokenQuery the active query used by this AR class.
     */
    public static function find()
    {
        return new SsoUserTokenQuery(get_called_class());
    }
}
