<?php

namespace app\modules\admin\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

class RestrictcoursesController extends \yii\web\Controller
{

 	/**
     * @inheritdoc
     */
    public function behaviors()
    {
		Yii::$app->controller->enableCsrfValidation = false;
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['index','submit','addrecord','deleterecord','getcourses'],
                        'allow' =>  Yii::$app->utility->isSuperAdmin(),
                    ],
                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) {
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],
            
        ];
    }

    public function actionIndex()
    {
		$param=array();
		
		
		$genderData = $this->getgenders();
		// Getting colleges Data :: 		
		$colleges = $this->getcolleges();
		       	
		$allrecords=$this->getAllrecords();
		
		$this->getAllCourseRestriction();
		
		
		//echo "<pre>=="; print_r($param); die();
        return $this->render('index',array('msg'=>$param,'genderdata'=>$genderData,'colleges'=>$colleges,'allrecords'=>$allrecords));
    }

	private function getactivesession(){
		   
		  $connection = Yii::$app->db;
		  $sql = "select * from session where Status='1'"; 
		  $command = $connection->createCommand($sql);
		  $session = $command -> queryOne();
		  return $session['SessionID'];
	}
	
	private function getgenders(){
		   
		  // Getting genders :: 
		$connection = Yii::$app->db;
		$query = "select * from erp_master_gender where gender_status='ACTIVE' AND gender_is_deleted='NO'";
        $model = $connection->createCommand($query);
		$genderData = $model->queryAll();
		return $genderData;
	}
	
	
	
	
	public function actionGetcourses(){
		 $connection = Yii::$app->db;
		  $id=$_POST['college_id'];
		  $isactive=1;
		  $dhe_legacy_collegecourse_is_deleted='NO';
		  $sessionid=$this->getactivesession();
		  $sql = "select distinct tab1.courseid from dhe_legacy_collegecourse tab1 inner join dhe_legacy_course tab2
				  on tab1.courseid=tab2.courseid where isactive='1' AND sessionid='$sessionid' AND
				  collegeid=$id AND tab1.dhe_legacy_collegecourse_is_deleted='$dhe_legacy_collegecourse_is_deleted'  "; 
		  $command = $connection->createCommand($sql);
		  $course_uuid = $command -> queryAll();
		  
			$course_details= array();
			$final_course_details=array();
			$yearstatus = 1;
		
				foreach($course_uuid as $k){
					$courseid=$k["courseid"];
					$dhe_legacy_coursesection_is_deleted="1";
					  $connection = Yii::$app->db;
					  $sql = "select CC.collegecourseid,CS.sectionname,CC.course_affiliation_type from  dhe_legacy_collegecourse  CC
							  inner join dhe_legacy_coursesection CS on CS.coursesectionid =CC.sectionid
							  Where CC.collegeid = $id and CS.courseid=$courseid and CC.isactive=$isactive and CC.sessionid = $sessionid and CS.yearstatus=$yearstatus  order by CS.sectionname ";
				     // echo "<pre>=="; print_r($sql); die();
					  $command = $connection->createCommand($sql);
					  
				      $course_details[] = $command -> queryAll();
				}

			return json_encode($course_details);
			
	}
	
	private function getcolleges(){
		
		  $connection = Yii::$app->db;
		  $sql = "select collegename,collegeid,college_uuid from dhe_legacy_college where collegeid_is_deleted='NO' AND affliationid <> 0 "; 
		  $command = $connection->createCommand($sql);
		  $colleges = $command -> queryAll();
		  
		  return $colleges; 
		
	}
	
	private function getcoursename($course_id,$college_id){
		
			$sessionid=$this->getactivesession();
			$isactive = 1;
			$course_details= array();
			$yearstatus = 1;
					
			$connection = Yii::$app->db;

			$sql = "select CS.sectionname as coursename from  dhe_legacy_collegecourse  CC
				  inner join dhe_legacy_coursesection CS on CS.coursesectionid =CC.sectionid
				  Where CC.collegeid = $college_id and CC.collegecourseid=$course_id and CC.isactive=$isactive and CC.sessionid = $sessionid and CS.yearstatus=$yearstatus order by CS.sectionname ";

			$command = $connection->createCommand($sql);
			//echo "<pre>====="; print_r($sql); die();
			$course_details = $command -> queryOne();
			return $course_details['coursename'];
		  
	}
	
	private function getgendername($gender_uuid){
		
		$connection = Yii::$app->db;

		$sql = "select gender_name as gendername from erp_master_gender where gender_uuid='$gender_uuid' and gender_is_deleted='NO'";

		$command = $connection->createCommand($sql);
		//echo "<pre>====="; print_r($sql); die();
		$gender_details = $command -> queryOne();
		return $gender_details['gendername'];
	}
	
	private function getAllrecords(){
		$connection = Yii::$app->db;
		$sql = "Select course_restriction.*,dhe_legacy_college.collegename from course_restriction inner join dhe_legacy_college on dhe_legacy_college.collegeid=course_restriction.college_id where course_restriction_is_deleted='NO' "; 
		$command = $connection->createCommand($sql);
		$records = $command -> queryAll();
		$i=0;
		foreach($records as $record){
			$records[$i]['coursename']=$this->getcoursename($record['course_id'],$record['college_id']);
			$records[$i]['gendername']=$this->getgendername($record['gender_uuid']);
			$i++;
		}
		
		
		//echo "<pre>====="; print_r($records); die();
		
		return $records;
		
	}
	
	private function getAllCourseRestriction(){
		$connection = Yii::$app->db;
		$sql = "Select * from course_restriction where course_restriction_is_deleted='NO' "; 
		$command = $connection->createCommand($sql);
		$records = $command -> queryAll();
			
		
		
		$html="";
		$i=0;
		foreach($records as $record){
			if($i <= 5){
				$html.= 'if("'.$record['gender_uuid'].'"==GENDER_UUID && "'.$record['course_id'].'"==combination_val){';
				$html.='$.alert("You can not apply for this course");';
				$html.='$("#combination_section_uuid").val("");';
				$html.='$("#combination_section_uuid").selectpicker("render");';
				$html.='$("#combination_section_uuid").selectpicker("refresh");';
				$html.='}';
			}
			if($i <= 10 && $i < 5){
				$html.= 'else if("'.$record['gender_uuid'].'"==GENDER_UUID && "'.$record['course_id'].'"==combination_val){';
				$html.='$.alert("You can not apply for this course");';
				$html.='$("#combination_section_uuid").val("");';
				$html.='$("#combination_section_uuid").selectpicker("render");';
				$html.='$("#combination_section_uuid").selectpicker("refresh");';
				$html.='}';
			}
			if($i <= 15 && $i < 10){
				$html.= 'else if("'.$record['gender_uuid'].'"==GENDER_UUID && "'.$record['course_id'].'"==combination_val){';
				$html.='$.alert("You can not apply for this course");';
				$html.='$("#combination_section_uuid").val("");';
				$html.='$("#combination_section_uuid").selectpicker("render");';
				$html.='$("#combination_section_uuid").selectpicker("refresh");';
				$html.='}';
			}
			if($i <= 20 && $i < 15){
				$html.= 'else if("'.$record['gender_uuid'].'"==GENDER_UUID && "'.$record['course_id'].'"==combination_val){';
				$html.='$.alert("You can not apply for this course");';
				$html.='$("#combination_section_uuid").val("");';
				$html.='$("#combination_section_uuid").selectpicker("render");';
				$html.='$("#combination_section_uuid").selectpicker("refresh");';
				$html.='}';
			}
			if($i <= 25 && $i < 20){
				$html.= 'else if("'.$record['gender_uuid'].'"==GENDER_UUID && "'.$record['course_id'].'"==combination_val){';
				$html.='$.alert("You can not apply for this course");';
				$html.='$("#combination_section_uuid").val("");';
				$html.='$("#combination_section_uuid").selectpicker("render");';
				$html.='$("#combination_section_uuid").selectpicker("refresh");';
				$html.='}';
			}
			if($i <= 30 && $i < 25){
				$html.= 'else if("'.$record['gender_uuid'].'"==GENDER_UUID && "'.$record['course_id'].'"==combination_val){';
				$html.='$.alert("You can not apply for this course");';
				$html.='$("#combination_section_uuid").val("");';
				$html.='$("#combination_section_uuid").selectpicker("render");';
				$html.='$("#combination_section_uuid").selectpicker("refresh");';
				$html.='}';
			}
			
			
			
			$i++;
		}
		
		
		//echo "<pre>====="; print_r($html); die();
		
		
		return $records;
	}
    
    public function actionAddrecord()
    {
    	$cnt=0;
    	if(isset($_POST['course_id'])){
			$course_restriction_uuid=$this->generateGuuid('CourseRestriction','course_restriction');
			$gender_uuid=$_POST['gender_uuid'];
    		$course_id=$_POST['course_id'];
			$college_id=$_POST['college_id'];
    		$connection = Yii::$app->db;
			$records=$this->checkrecord($_POST['college_id'],$_POST['course_id']);
			
			if(!empty($records)){
				$param['custommsg']="Record is already there. Please delete that record and add new.";
				$param['customstatus']=400;
				$genderData = $this->getgenders();
				$colleges = $this->getcolleges();
		       	$allrecords=$this->getAllrecords();
				return $this->render('index',array('msg'=>$param,'genderdata'=>$genderData,'colleges'=>$colleges,'allrecords'=>$allrecords));
				exit;
				
			}
			else{
				$update="insert into course_restriction (course_restriction_uuid,gender_uuid,course_id,college_id) values ('$course_restriction_uuid','$gender_uuid','$course_id','$college_id')";
				$command = $connection->createCommand($update);
				$new_row=$command->execute();
				
			}
			
    	}
    	
    	$param=array();
		if($new_row){
			$param['custommsg']="Record for is Successfully Added.";
			$param['customstatus']=200;
			
		}
		else{
			$param['custommsg']="Error: try again";
			$param['customstatus']=400;
		}
		$genderData = $this->getgenders();
		$colleges = $this->getcolleges();
		$allrecords=$this->getAllrecords();
		return $this->render('index',array('msg'=>$param,'genderdata'=>$genderData,'colleges'=>$colleges,'allrecords'=>$allrecords));
    }
	
	
	// checked ::
	private function checkrecord($college_id,$course_id){
		$connection = Yii::$app->db;
		$sql = "Select * from course_restriction where college_id='$college_id' and course_id='$course_id'  and course_restriction_is_deleted='NO'"; 
		$command = $connection->createCommand($sql);
		$record = $command -> queryOne();
		return $record;
	}
	
	public function actionDeleterecord(){
		$connection = Yii::$app->db;
		$id=$_GET['id'];
		$sql="UPDATE course_restriction SET course_restriction_is_deleted ='YES' where course_restriction_id= '$id'";
		$command = $connection->createCommand($sql);
		$new_row=$command->execute();
		
		if($new_row){
			$param['custommsg']="Record is Successfully Deleted.";
			$param['customstatus']=200;
			
		}
		else{
			$param['custommsg']="Error: try again";
			$param['customstatus']=400;
		}
		$genderData = $this->getgenders();
		$colleges = $this->getcolleges();
		$allrecords=$this->getAllrecords();
		return $this->render('index',array('msg'=>$param,'genderdata'=>$genderData,'colleges'=>$colleges,'allrecords'=>$allrecords));
	}
	
	private function generateGuuid($moduleName, $tableName)
 {
    $time = microtime();
    $randValue = rand(10000000,99999999);
    $firstmd5 = md5($time.$randValue);

    $time = microtime();
    $randValue = rand(10000000,99999999);
    $secondmd5 = md5($moduleName.$tableName.$randValue);

    $guuid = $firstmd5.$secondmd5;
    return strtoupper($guuid);
 }
	
	
	
	
	

}
