<?php

namespace app\modules\admin\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

class SmsController extends \yii\web\Controller
{

 	/**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['index','submit'],
                        'allow' =>  Yii::$app->utility->isSuperAdmin(),
                    ],
                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) {
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],
            
        ];
    }

    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionSubmit()
    {
    	$cnt=0;
    	if(isset($_POST['sms'])){
    		$sms=$_POST['sms'];
    		$sms_array=explode(",",$sms);
    		foreach($sms_array as $sms){
    			$mobile=trim($sms);
    			$content=$_POST['msg'];
    			
    			if( strlen($mobile)==10 ){
    				//echo "<br /> $mobile |  $content"; 				
    				$res=Yii::$app->utility->pushSMS($mobile, $content);
    				if(isset($res['000'])){
    					$cnt++;
    				}
    			}
    		}
    	}
    	
    	$param=array();
    	$param['msg']="$cnt SMS Sent";
    	
        return $this->render('index',$param);
    }

}
