<?php

namespace app\modules\admin\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\base\Exception;

class StudentsmsController extends \yii\web\Controller
{

 	/**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['index','submit','coursewiseonoff','getcourses'],
                        'allow' =>  Yii::$app->utility->isSuperAdmin(),
                    ],
                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) {
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],
            
        ];
    }

public function actionIndex2(){
	
  return $this->render('index');

}
	
	
public function actionIndex(){

    $REG_NO=strip_tags($_POST['registration_number']);
    $MOB_NO=strip_tags($_POST['mobile_number']);
	$model=array();

	if( empty($_POST) ){
		return $this->render('index');
	}

	try{


		if( $REG_NO!="" || $MOB_NO!="" ){

			$connection = \Yii::$app->db;
			$sql = "SELECT dhe_sms_receiver_number,dhe_sms_message,dhe_sms_status,dhe_sms_type ,dhe_sms_created_date
						FROM `dhe_sms_history`
						WHERE `dhe_sms_type` = 'REGISTRATION' ";
	
			if( isset($REG_NO) && $REG_NO!="" )$sql .=" AND dhe_sms_message like '%$REG_NO%' ";
			if( isset($MOB_NO) && $MOB_NO!="" )$sql .=" AND dhe_sms_receiver_number = '".$MOB_NO."' ";
			
			$query = $connection->createCommand($sql);
			$model = $query->queryAll();
			
	
		}else{

			throw new Exception('Please enter valid registation number or mobile number.');
		}



		if(count($model) > 0) {
		
			$record['msg'] = "Record found Successfully!";
			$record['status'] = 200;
			$record['smsdata'] = $model;
			
		} else {

			$record['msg'] = "Record Not Found!";
			$record['status'] = 201;
			$record['smsdata'] = "";
		}
		
		
		return $this->render('index', $record);

	}catch(Exception $e){

		$record['msg'] = $e->getMessage();
		$record['status'] = 203;
		$record['smsdata'] = "";
		return $this->render('index', $record );


	}
	
	


	
	 
		
  


    
}
	
	

	
	
	

}
