<?php

namespace app\modules\admin\controllers;

use Yii;
use app\models\ApplicantInfo;
use app\models\PaymentHistory;
use app\models\ApplicantApplicationCourseChoice;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;



class FeeController extends \yii\web\Controller
{

 	/**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'rules' => [
                    [
                        'actions' => ['index','submit','getpaymentdetails','multiplefeeapplicants'],
                        'allow' =>  Yii::$app->utility->isSuperAdmin(),
                    ],
                ],
                'denyCallback' => function ($rule, $action) {
                    if (Yii::$app->utility->isSuperAdmin() === false) { 
                        return $action->controller->redirect(BASE_URL.'/site/login');
                    }
                    throw new ForbiddenHttpException("Forbidden access");
                }
            ],
            
        ];
    }

    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionSubmit()
    {
		
		
		
		
    	
    	$param=array();
    	$param['msg']="Record has been updated";
    	
        return $this->render('index',$param);
    }
	
	public function actionGetpaymentdetails(){
		
		$params=array();
		
			if(isset($_POST['registration_number'])){
				$registration_number=$_POST['registration_number'];
				 $applicantmodel = ApplicantInfo::find()
				->where('applicant_info_registration_number = :applicant_info_registration_number', [':applicant_info_registration_number' => $registration_number])
				->one();
				$applicant_uuid=$applicantmodel["applicant_info_uuid"];
				$params['applicant_uuid']=$applicant_uuid;
				$applicationcollegemodel = ApplicantApplicationCourseChoice::find()
				->where('applicant_application_uuid = :applicant_uuid', [':applicant_uuid' => $applicant_uuid])
				->asArray()
				->select('college_uuid')
				->distinct()
				->all();
				
				$applicationmodel = ApplicantApplicationCourseChoice::find()
				->where('applicant_application_uuid = :applicant_uuid', [':applicant_uuid' => $applicant_uuid])
				->asArray()
				//->distinct('college_uuid')
				//->count();
				->all();
				
				
			
				
								
				$paymentmodel = PaymentHistory::find()
				->where('applicant_uuid = :applicant_uuid', [':applicant_uuid' => $applicant_uuid])
				->all();
				
				// SUCCESS amount
				$connection = Yii::$app->db;
				$query = "select * from payment_history inner join payment_details_billdesk
						  on payment_history.payment_details_uuid=payment_details_billdesk.payment_details_billdesk_uuid where 
						  payment_history_status='SUCCESS' and applicant_uuid='$applicant_uuid'";
				$model = $connection->createCommand($query);
				$data = $model->queryAll();
				$params['successful_transactions']=$successful_transactions=count($data);
				$total_amount_paid=0;
				foreach($data as $k){
					
					$total_amount_paid=$total_amount_paid + $k['txn_amount'];
					
				}
				
				
					//echo json_encode($data); die;	
				
				// Pending records and number of tries
				$connection = Yii::$app->db;
				$pending_query = "select * from payment_history inner join payment_details_billdesk
						  on payment_history.payment_details_uuid=payment_details_billdesk.payment_details_billdesk_uuid where 
						  payment_history.payment_history_status='PENDING'  AND applicant_uuid='$applicant_uuid'";
				$pending_model = $connection->createCommand($pending_query);
				$pending_data = $pending_model->queryAll();
				
				$no_of_tries=count($pending_data);
				$params['no_of_tries']=$no_of_tries;
				
				
				
				// Pending Amount
				$connection = Yii::$app->db;
				$pending_amount_query = "select * from payment_history inner join payment_details_billdesk
						  on payment_history.payment_details_uuid=payment_details_billdesk.payment_details_billdesk_uuid where 
						  payment_history.payment_history_status='PENDING' AND payment_details_billdesk.payment_details_billdesk_status='PENDING' AND applicant_uuid='$applicant_uuid'";
				$pending_amount_model = $connection->createCommand($pending_amount_query);
				$pending_amount_data = $pending_amount_model->queryAll();
				$params['pending_transactions']=$pending_transactions=count($pending_amount_data);
				
				$total_pending_amount=0;
				foreach($pending_amount_data as $k){
					
					$total_pending_amount=$total_pending_amount + $k['txn_amount'];
					
				}				


				
				$count_all_applications=0;
				$count_distinct_applied_colleges=0; 
				$actual_amount=0;
				
				//assigning
				$count_all_applications=count($applicationmodel);
				$count_distinct_applied_colleges=count($applicationcollegemodel);
				$actual_amount=$count_distinct_applied_colleges * 150;
				
				
				
				// DATA :  
				$params["actual_amount"]=$actual_amount;
				$params["count_distinct_applied_colleges"]=$count_distinct_applied_colleges;
				$params["total_amount_paid"]=$total_amount_paid;
				$params["refund_amount"]=$total_amount_paid-$actual_amount;
				$params["total_pending_amount"]=$total_pending_amount;
				
			
				
				$i=1;
				$htm = "";
				
				 $htm .= "<thead>";
				 $htm .= "<th>Sno</th>";
				 $htm .= "<th>Payment status uuid</th>";
				 $htm .= "<th>Applicant uuid</th>";
				 $htm .= "<th>Payment Status</th>";
				 $htm .= "<th>Created Date</th>";
				 $htm .= "<thead>";
				foreach($applicationmodel as $v){
						
							  if($v["application_course_choice_payment_status"] == "SUCCESS"){
								  $htm .= "<tr>";
								  $htm .= "<td width='5%'>".$i."</td>";
								  $htm .= "<td width='20%'>".$v["application_payment_status_uuid"]."</td>";
								  $htm .= "<td width='20%'>".$v["applicant_application_uuid"]."</td>";
								  $htm .= "<td width='10%'>".$v["application_course_choice_payment_status"]."</td>";
								  $htm .= "<td width='10%'>".$v["application_course_choice_created_date"]."</td>";
								$htm .= "</tr>";
							  }
							
					$i++;
                }
				
				$j=1;
				$htmm = "";
				
				 $htmm .= "<thead>";
				 $htmm .= "<th>Sno</th>";
				 $htmm .= "<th>Payment status uuid</th>";
				 $htmm .= "<th>Applicant uuid</th>";
				 $htmm .= "<th>Payment Status</th>";
				 $htmm .= "<th>Created Date</th>";
				 $htmm .= "<thead>";
				foreach($applicationmodel as $v){
						
							  if($v["application_course_choice_payment_status"] == "PENDING"){
								  $htmm .= "<tr>";
								  $htmm .= "<td width='5%'>".$j."</td>";
								  $htmm .= "<td width='20%'>".$v["application_payment_status_uuid"]."</td>";
								  $htmm .= "<td width='20%'>".$v["applicant_application_uuid"]."</td>";
								  $htmm .= "<td width='10%'>".$v["application_course_choice_payment_status"]."</td>";
								  $htmm .= "<td width='10%'>".$v["application_course_choice_created_date"]."</td>";
								$htmm .= "</tr>";
							  }
							
					$j++;
                }
				
				
				/// Transaction details ::
				$k=1;
				$htmpp = "";
				
				 $htmpp .= "<thead>";
				 $htmpp .= "<th>Sno</th>";
				 $htmpp .= "<th>Customer ID</th>";
				 $htmpp .= "<th>Amount</th>";
				 $htmpp .= "<th>Created Date</th>";
				 $htmpp .= "<th>Status</th>";
				 $htmpp .= "<thead>";
				foreach($pending_amount_data as $v){
						
							 
								  $htmpp .= "<tr>";
								  $htmpp .= "<td width='5%'>".$k."</td>";
								  $htmpp .= "<td width='20%'>".$v["customer_id"]."</td>";
								  $htmpp .= "<td width='20%'>".$v["txn_amount"]."</td>";
								  $htmpp .= "<td width='10%'>".$v["payment_details_billdesk_created_date"]."</td>";
								  $htmpp .= "<td width='10%'>".$v["payment_details_billdesk_status"]."</td>";
								  $htmpp .= "</tr>";
							 
							
					$k++;
                }
				
				$l=1;
				$htms = "";
				
				 $htms .= "<thead>";
				 $htms .= "<th>Sno</th>";
				 $htms .= "<th>Transaction ID</th>";
				 $htms .= "<th>Amount</th>";
				 $htms .= "<th>Txn Date</th>";
				 $htms .= "<th>Status</th>";
				 $htms .= "<thead>";
				foreach($data as $v){
						
							  
								  $htms .= "<tr>";
								  $htms .= "<td width='5%'>".$l."</td>";
								  $htms .= "<td width='20%'>".$v["txn_id"]."</td>";
								  $htms .= "<td width='20%'>".$v["txn_amount"]."</td>";
								  $htms .= "<td width='10%'>".$v["txn_date"]."</td>";
								  $htms .= "<td width='10%'>".$v["payment_details_billdesk_status"]."</td>";
								$htms .= "</tr>";
							
							
					$l++;
                }
				
				 
				
				
				
				
				$params['html'] = $htm;
				$params['html_pending'] = $htmm;
				$params['succesfull_transactions_details'] = $htms;
				$params['pending_transactions_details'] = $htmpp;
				$params['timeline_link'] = "<a target='_blank' class='btn btn-primary' href='http://dhe.weexceldemo.com/backend/sso/web/index.php/admin/fee/multiplefeeapplicants/$applicant_uuid'>View Full Timeline</a>";
				echo json_encode($params); die;
				//return $this->render('index',$applicant_uuid);
				
				
				// Debugging ::
				// echo "<pre>"; print_r($params["applicationmodel"]); die;
				// die(" I AM HERE ");
				// return $this->render('index',$params);
				// 
    		 
			}
    	
    
		
	}
	
	
	    public function actionMultiplefeeapplicants(){
			
        if($_GET)
        {
            $params=array();
            $connection = Yii::$app->db;

            $applicant_uuid = $_GET['applicant_uuid'];
            //$application_uuid = "C889BAE2126B439865E91F549CC079E447CB35F279531D13EC1C9170CB7A0A5B";
            $query = "select tab2.college_uuid, tab2.application_payment_status_uuid, tab1.payment_type, 
			tab1.payment_details_uuid, tab1.applicant_uuid, tab1.payment_history_status, tab1.created_date_time,
			tab2.application_fee, tab2.application_course_choice_payment_status, tab2.application_application_number,
			tab2.application_course_choice_preference 
			from payment_history tab1 inner join applicant_application_course_choice tab2 
			on tab1.applicant_uuid = tab2.applicant_application_uuid 
			where tab1.applicant_uuid = '".$applicant_uuid."'";
            
            $model = $connection->createCommand($query);
            $applicationdata = $model->queryAll();
            
            //echo "<pre>";print_r($applicationdata);exit;
            
            if(count($applicationdata) != 0)
            {
                $params['applicationdata'] = $applicationdata;
                return $this->render('multiplefeeapplicantform', $params);
            }
            else
            {
                echo "No record found of this Application UUID.";
                exit;
            }
        }
        else
        {
            throw new \yii\web\HttpException(400, 'Invalid request. Please enter application uuid');
            exit;
        }
    }


}
